#!/bin/sh
# © Copyright [2019 - 2020] Micro Focus or one of its affiliates.
#
# The only warranties for products and services of Micro Focus and its affiliates and licensors
# (“Micro Focus”) are as may be set forth in the express warranty statements accompanying such
# products and services. Nothing herein should be construed as constituting an additional
# warranty. Micro Focus shall not be liable for technical or editorial errors or omissions
# contained herein. The information contained herein is subject to change without notice.
#
# Except as specifically indicated otherwise, this document contains confidential information
# and a valid license is required for possession, use or copying. If this work is provided to the
# U.S. Government, consistent with FAR 12.211 and 12.212, Commercial Computer Software,
# Computer Software Documentation, and Technical Data for Commercial Items are licensed
# to the U.S. Government under vendor's standard commercial license.

# This file is used to copy all the required configuration files to non-default path based on user preference Ex: ncs volume

update_cis(){
    prefix_path=$1
    prefix_path_letc=$prefix_path/etc/opt/novell/cis
    prefix_path_lvar=$prefix_path/var/opt/novell/log/cis

    #Create all required directory in the new path
    mkdir -p $prefix_path/etc/opt/novell/cis
    mkdir -p $prefix_path/var/opt/novell/log/cis
    mkdir -p $prefix_path_letc/analytics/data
    mkdir -p $prefix_path_letc/fluentbit
    mkdir -p $prefix_path_letc/kafka
    mkdir -p $prefix_path_letc/kafka/certs
    mkdir -p $prefix_path_letc/kafka/kafka-logs
    mkdir -p $prefix_path_letc/zk
    mkdir -p $prefix_path_letc/zk/data
    mkdir -p $prefix_path_letc/zk/datalog
    mkdir -p $prefix_path_letc/backup/certs/rootCAs
    mkdir -p $prefix_path_lvar/microservices
    mkdir -p $prefix_path_letc/db/certs/

    #Copy all required configuration files to the new media path
    [[ -d /etc/opt/novell/cis/.creds ]] && cp -rp /etc/opt/novell/cis/.creds $prefix_path_letc/
    [[ -d /etc/opt/novell/cis/certs ]] && cp -rp /etc/opt/novell/cis/certs $prefix_path_letc/
    [[ -d /etc/opt/novell/cis/gateway ]] && cp -rp /etc/opt/novell/cis/gateway $prefix_path_letc/
    [[ -f /etc/opt/novell/cis/config ]] && cp -p /etc/opt/novell/cis/config $prefix_path_letc/config
    [[ -f /etc/opt/novell/cis/cis3.yml ]] && cp -p /etc/opt/novell/cis/cis3.yml $prefix_path_letc/cis3.yml
    [[ -f /etc/opt/novell/cis/cis5.yml ]] && cp -p /etc/opt/novell/cis/cis5.yml $prefix_path_letc/cis5.yml
    [[ -f /etc/opt/novell/cis/cis7.yml ]] && cp -p /etc/opt/novell/cis/cis7.yml $prefix_path_letc/cis7.yml
    [[ -f /etc/opt/novell/cis/status.json ]] && cp -p /etc/opt/novell/cis/status.json $prefix_path_letc/status.json
    [[ -f /etc/opt/novell/cis/configurationStatus.json ]] && cp -p /etc/opt/novell/cis/configurationStatus.json $prefix_path_letc/configurationStatus.json
    [[ -d /etc/opt/novell/cis/db/certs/ ]] && cp -rp /etc/opt/novell/cis/db/certs/ $prefix_path_letc/db/
    [[ -f /etc/opt/novell/cis/analytics/config ]] && cp -p /etc/opt/novell/cis/analytics/config $prefix_path_letc/analytics/config
    [[ -d /etc/opt/novell/cis/analytics/data ]] && cp -rp /etc/opt/novell/cis/analytics/data $prefix_path_letc/analytics/
    [[ -f /etc/opt/novell/cis/analytics/os_envoy.json ]] && cp -p /etc/opt/novell/cis/analytics/os_envoy.json $prefix_path_letc/analytics/os_envoy.json
    [[ -f /etc/opt/novell/cis/analytics/log4j2.properties ]] && cp -p /etc/opt/novell/cis/analytics/log4j2.properties $prefix_path_letc/analytics/log4j2.properties
    [[ -f /etc/opt/novell/cis/analytics/opensearch.yml ]] && cp -p /etc/opt/novell/cis/analytics/opensearch.yml $prefix_path_letc/analytics/opensearch.yml
    [[ -f /etc/opt/novell/cis/os_envoy.json ]] && cp -p /etc/opt/novell/cis/os_envoy.json $prefix_path_letc/os_envoy.json
    [[ -d /etc/opt/novell/cis/fluentbit ]] && cp -rp /etc/opt/novell/cis/fluentbit $prefix_path_letc/
    [[ -f /etc/opt/novell/cis/fluentbit/config ]] && cp -p /etc/opt/novell/cis/fluentbit/config $prefix_path_letc/fluentbit/config
    [[ -f /etc/opt/novell/cis/fluentbit/fluentd.conf ]] && cp -p /etc/opt/novell/cis/fluentbit/fluentd.conf $prefix_path_letc/fluentbit/fluentd.conf
    [[ -f /etc/opt/novell/cis/health.json ]] && cp -p /etc/opt/novell/cis/health.json $prefix_path_letc/health.json
    [[ -d /etc/opt/novell/cis/kafka/certs ]] && cp -rp /etc/opt/novell/cis/kafka/certs $prefix_path_letc/kafka/
    [[ -f /etc/opt/novell/cis/kafka/config ]] && cp -p /etc/opt/novell/cis/kafka/config $prefix_path_letc/kafka/config
    [[ -d /etc/opt/novell/cis/kafka/kafka-logs ]] && cp -rp /etc/opt/novell/cis/kafka/kafka-logs $prefix_path_letc/kafka/
    [[ -f /etc/opt/novell/cis/kafka/kafka_envoy.json ]] && cp -p /etc/opt/novell/cis/kafka/kafka_envoy.json $prefix_path_letc/kafka/kafka_envoy.json
    [[ -f /etc/opt/novell/cis/kafka/log4j.properties ]] && cp -p /etc/opt/novell/cis/kafka/log4j.properties $prefix_path_letc/kafka/log4j.properties
    [[ -f /etc/opt/novell/cis/nginx.conf ]] && cp -p /etc/opt/novell/cis/nginx.conf $prefix_path_letc/nginx.conf
    [[ -f /etc/opt/novell/cis/zk/config ]] && cp -p /etc/opt/novell/cis/zk/config $prefix_path_letc/zk/config
    [[ -d /etc/opt/novell/cis/zk/data ]] && cp -rp /etc/opt/novell/cis/zk/data $prefix_path_letc/zk/
    [[ -d /etc/opt/novell/cis/zk/datalog ]] && cp -rp /etc/opt/novell/cis/zk/datalog $prefix_path_letc/zk/
    [[ -f /etc/opt/novell/cis/zk/log4j.properties ]] && cp -p /etc/opt/novell/cis/zk/log4j.properties $prefix_path_letc/zk/log4j.properties
    [[ -f /etc/opt/novell/cis/zk/zk_envoy.json ]] && cp -p /etc/opt/novell/cis/zk/zk_envoy.json $prefix_path_letc/zk/zk_envoy.json
    [[ -f /etc/opt/novell/cis/zk_envoy.json ]] && cp -p /etc/opt/novell/cis/zk_envoy.json $prefix_path_letc/zk_envoy.json
    [[ -d /etc/opt/novell/cis/backup ]] && cp -rp /etc/opt/novell/cis/backup $prefix_path_letc
    [[ -d /etc/opt/novell/cis/backup/certs ]] && cp -rp /etc/opt/novell/cis/backup/certs $prefix_path_letc/backup
    [[ -d /etc/opt/novell/cis/backup/certs/rootCAs ]] && cp -rp /etc/opt/novell/cis/backup/certs/rootCAs $prefix_path_letc/certs/

    [[ -f /var/opt/novell/log/cis/cisconfiguration.log ]] && mv /var/opt/novell/log/cis/cisconfiguration.log $prefix_path_lvar/cisconfiguration.log
    [[ -d /var/opt/novell/log/cis/microservices ]] && mv /var/opt/novell/log/cis/microservices $prefix_path_lvar/

    chown -R admin $prefix_path_letc/analytics/data/* > /dev/null 2>&1
    chown -R root:root $prefix_path_letc/zk/data/* > /dev/null 2>&1
    chown -R root:root $prefix_path_letc/zk/datalog/* > /dev/null 2>&1

    ln -fsn $prefix_path_letc /etc/opt/novell/cis
    ln -fsn $prefix_path_lvar /var/opt/novell/log/cis
}

# If path is root, don't perform any movement
[[ "$1" == "/" ]] && exit 0

update_cis $1
exit 0
